<?php
/*
	Redaxo-Addon RexTree
	Funktionen für globale Einbindung (BE only)
	v1.1
	by Falko Müller @ 2010-2013
	package: redaxo4
*/

$a136_rexTree = "";

//Std.vorgaben auslesen
$db = rex_sql::factory();
$db->setQuery("SELECT * FROM ".$REX['TABLE_PREFIX']."136_rextree_config limit 0,1"); 
$rexTreeCfg = $db->getArray();	//mehrdimensionales Array kommt raus
	$rexTreeCfg[0]['maxchars'] = 25;

function a136_showTree($params)
{	global $REX, $REX_ARTICLE, $I18N;
	global $a136_rexTree;
	global $rexTreeCfg;
	//session_start();

	//Variablen deklarieren
	$mypage = "rextree";

	$newOP = $params['subject'];
	$page = rex_request('page');
	$stcArr = array("structure", "content");	//Definition der gültigen Seiten, wo die Strukturerweiterungen greifen sollen, sofern nicht überall einzubinden
	$stcAll = $rexTreeCfg[0]['allsites'];		//Parameter, um Tree in allen bereichen anzeigen zu lassen
	

	//zus. Prüfroutine um doppelte Einbindung bei Fehlern in Fremdaddons zu vermeiden
	$searchTREE = "<\!-- END \:\: RexTree Output -->";
	if (!preg_match("/".$searchTREE."/si", $newOP)):
		//Eibindung noch nicht erfolgt -> einbinden		

		/* zus. Tree-Container einbinden (nur wenn auf Strukturseite) */
		if ((in_array($page, $stcArr) || ($stcAll == 1 && $page != "mediapool" && $page != "linkmap"))):
			//Tree holen
			a136_getRexTree();
			
			//Ausgabevorgaben
			$treeWidth = 200;	//Breite des Treecontainers (px)
			$treeMargin = 16;	//Margin links (px)
			
			//neue gesamtbreite setzen
			$rexStdWidth = 964;	//Breite des id="rex-website"
				$rexNewWidth = intval($rexStdWidth) + intval($treeWidth) + intval($treeMargin);
				
			//auf aktiven be_settings-Plugin prüfen und Werte neu berechnen
			$searchBES = "plugins\/style_settings\/(.*[0-9])\.width_agk\.css";
			preg_match("/".$searchBES."/si", $newOP, $regs);
				if (count($regs) >= 2):
					$besWidth = intval($regs[1]);
						if ($besWidth > 0 && $besWidth != $rexStdWidth):
							$rexNewWidth = intval($besWidth) + intval($treeWidth) + intval($treeMargin);
						endif;
				endif;
				
			//neuen Ausgabecode zusammensetzen
			$cssWidth = $treeWidth.'px';
			$cssMargin = $treeMargin.'px';
				//Ausrichtung
				if ($rexTreeCfg[0]['align'] == 1):
					$cssFloat = "float: right; margin-right: ".$treeMargin."px; margin-left: 0px";
				else:
					$cssFloat = "";
				endif;
				
				//Sprache
				$strucheader = $I18N->msg('a136_structureheader');
				$strucopen = $I18N->msg('a136_structureopen');
				$strucclose = $I18N->msg('a136_structureclose');
				$con_opennw = $I18N->msg('a136_context_opennewwindow');
				$con_newcat = $I18N->msg('a136_context_newcat');
				$con_newart = $I18N->msg('a136_context_newart');
				$con_online = $I18N->msg('a136_context_online');
				$con_offline = $I18N->msg('a136_context_offline');
				$con_prop = $I18N->msg('a136_context_prop');
				$con_content = $I18N->msg('a136_context_content');
				$con_delcat = $I18N->msg('a136_context_delcat');
				$con_delart = $I18N->msg('a136_context_delart');
				
$oprextree = <<<EOD
	
	<!-- START :: RexTree Output -->
	<div class="contextMenu" id="rextreeRightmenu" style="display: none;">
		<ul>
			<li id="opennw">$con_opennw</li>
			
			<li class="rextreeCmenuHR"></li>
			
			<li id="newcat">$con_newcat</li>
			<li id="newart">$con_newart</li>
			<li id="oncat">$con_online</li>
			<li id="offcat">$con_offline</li>
			<li id="rencat">$con_prop</li>
			
			<li id="editart">$con_content</li>
			<li id="onart">$con_online</li>
			<li id="offart">$con_offline</li>
			<li id="renart">$con_prop</li>
			
			<li id="rextreeCmenuHR"></li>
			
			<li id="delcat">$con_delcat</li>
			<li id="delart">$con_delart</li>
		</ul>
	</div>
	<div id="rex-tree" style="width: $cssWidth; margin-left: $cssMargin; $cssFloat;">
		<dl class="rex-tree_inner">
			<dt><a href="index.php?page=structure" class="strucheader">$strucheader</a> <div id="rex-tree_expand"><a href="#"><img src="../files/addons/$mypage/icon_up.gif" width="12" height="8" alt="$strucclose" title="$strucclose" /></a> <a href="#"><img src="../files/addons/$mypage/icon_down.gif" width="12" height="8" alt="$strucopen" title="$strucopen" /></a></div></dt>
			<dd>$a136_rexTree</dd>
		</dl>
	</div>
	<div id="rex-wrapper">
	<!-- END :: RexTree Output -->
	
EOD;
	
	
			//Rexcontainer anpassen
			$search[0] = '<div id="rex-wrapper">';
			$replace[0] = $oprextree;
			
			//id="rex-website" verbreitern, um alles einpassen zu können (original = 964px)
			$search[1] = '<div id="rex-website">';
			$replace[1] = '<div id="rex-website" style="width: '.$rexNewWidth.'px;">';	//dynamisch mit width=auto geht nicht
		
			$newOP = str_replace($search, $replace, $newOP);
		endif;	
		
	endif;
	
	//Ausgabe freigeben	
    return $newOP;
}

function a136_custBE($params)
{	global $REX, $REX_ARTICLE, $I18N;
	global $rexTreeCfg;
	//session_start();
	
	//Variablen deklarieren
	$newOP = $params['subject'];

	if ($rexTreeCfg[0]['gui'] == 1):
		/* zus. Frontend-Button einbinden (permanent) */
		$search[0] = '</li><li><a href="index.php?page=profile">';
		$replace[0] = '</li><li><a href="../index.php" target="_blank">'.$I18N->msg('a136_frontend').'</a></li><li><a href="index.php?page=profile">';
			$newOP = str_replace($search, $replace, $newOP);
		
		/* Platz für weitere Änderungen */

	endif;
	
	//Ausgabe freigeben	
    return $newOP;
}

function a136_addAssets($params)
{	global $REX, $REX_ARTICLE;
	global $rexTreeCfg;

	//Variablen deklarieren
	$mypage = "rextree";

	//CSS und JS anfügen
	$params['subject'] .= '<link rel="stylesheet" type="text/css" href="../files/addons/'.$mypage.'/rextree.css" />';
	$params['subject'] .= '<script type="text/javascript" src="../files/addons/'.$mypage.'/jquery.cookie.js"></script>';
	$params['subject'] .= '<script type="text/javascript" src="../files/addons/'.$mypage.'/jquery.treeview.js"></script>';
	$params['subject'] .= '<script type="text/javascript" src="../files/addons/'.$mypage.'/rextree.js"></script>';
	if ($rexTreeCfg[0]['context'] == 1):
		$params['subject'] .= '<script type="text/javascript" src="../files/addons/'.$mypage.'/jquery.contextmenu.r2.packed.js"></script>';
		$params['subject'] .= '<script type="text/javascript" src="../files/addons/'.$mypage.'/rextreecontext.js"></script>';
	endif;
  
	return $params['subject'];
}

function a136_getRexTree($ebene = 0)
{	//$ebene = intval($ebene);
	global $a136_rexTree;
	global $REX, $I18N;
	global $rexTreeCfg;

	if (empty($ebene)):
		$a136_rexTree .= '<ul id="rex-treeview" class="rex-treeview">';
	else:
		$a136_rexTree .= '<ul>';
	endif;
	
	if (empty($ebene)):
		//Root-Kategorien holen
		foreach (OOCategory::getRootCategories() as $cat):
			//Aktivstatus prüfen
			if ($cat->isOnline() == true):
				$catStatus = "showCatOn";
				$catClass = "";
			else:
				$catStatus = "showCatOff";
				$catClass = " directory_offline";
			endif;
			
			//Linkname aufbereiten
			$linkname = a136_getName($cat->getName(), $cat->getId(), 2);
		
			$a136_rexTree .= "\t<li>";
			$a136_rexTree .= '<a href="index.php?page=structure&amp;category_id='.$cat->getId().'&amp;clang='.$cat->getClang().'" class="directory'.$catClass.'" rev="'.$cat->getId().'|0|'.$REX['CUR_CLANG'].'" id="'.$catStatus.'" title="'.str_replace('"', "&quot;", $cat->getName()).' (ID: '.$cat->getId().')">'.$linkname.'</a>';
			
			//$childs = sizeof($cat->getChildren());
				//if ($childs > 0):
					//Rekursion
					a136_getRexTree($cat);
				//endif;
				
			$a136_rexTree .= "</li>\n";
		endforeach;
		
		//Root-Artikel auslesen
		$rootArts = OOArticle::getRootArticles(false, $REX['CUR_CLANG']);
			foreach ($rootArts as $rootArt):
				//Startartikel anders markieren
				if ($rootArt->isSiteStartArticle() == true):
					$artClass = "sitestartarticle";
						if ($rootArt->isOnline() == false):
							$artClass .= " sitestartarticle_offline";
						endif;
				elseif ($rootArt->isStartArticle() == true):
					$artClass = "startarticle";
				else:
					$artClass = "normarticle";
						if ($rootArt->isOnline() == false):
							$artClass .= " normarticle_offline";
						endif;
				endif;
				
				//Aktivstatus prüfen
				if ($rootArt->isStartArticle() != true && $rootArt->isOnline() == true):
					$artStatus = "showArtOn";
				elseif ($rootArt->isStartArticle() != true && $rootArt->isOnline() == false):
					$artStatus = "showArtOff";
				else:
					$artStatus = "showArtStart";
				endif;
			
				//Linkname aufbereiten
				$linkname = a136_getName($rootArt->getName(), $rootArt->getId(), 1);
				
				$a136_rexTree .= "\t<li>";
				$a136_rexTree .= '<a href="index.php?page=content&amp;article_id='.$rootArt->getId().'&amp;mode=edit&amp;clang='.$rootArt->getClang().'&amp;category_id=0" class="'.$artClass.'" rev="'.$rootArt->getId().'|0|'.$REX['CUR_CLANG'].'" id="'.$artStatus.'" title="'.str_replace('"', "&quot;", $rootArt->getName()).' (ID: '.$rootArt->getId().')">'.$linkname.'</a>';
				$a136_rexTree .= "</li>\n";
			endforeach;
	else:
		//Kategorie-Kindselemente holen - aus Object
		foreach ($ebene->getChildren() as $cat):
			//Aktivstatus prüfen
			if ($cat->isOnline() == true):
				$catStatus = "showCatOn";
				$catClass = "";
			else:
				$catStatus = "showCatOff";
				$catClass = " directory_offline";
			endif;
			
			//Linkname aufbereiten
			$linkname = a136_getName($cat->getName(), $cat->getId());

$a136_rexTree .= "\t<li>";
			$a136_rexTree .= '<a href="index.php?page=structure&amp;category_id='.$cat->getId().'&amp;clang='.$cat->getClang().'" class="directory'.$catClass.'" rev="'.$cat->getId().'|'.$ebene->getId().'|'.$REX['CUR_CLANG'].'" id="'.$catStatus.'" title="'.str_replace('"', "&quot;", $cat->getName()).' (ID: '.$cat->getId().')">'.$linkname.'</a>';
			
			/*$childs = sizeof($cat->getChildren());
				if ($childs > 0):*/
					//Rekursion
					a136_getRexTree($cat);
				/*endif;*/
				
			$a136_rexTree .= "</li>\n";
		endforeach;
		
		//Artikel der übergordneten Kat auslesen
		$catArts = $ebene->getArticles(false);
			foreach ($catArts as $catArt):
				//Startartikel anders markieren
				if ($catArt->isSiteStartArticle() == true):
					$artClass = "sitestartarticle";
						if ($catArt->isOnline() == false):
							$artClass .= " sitestartarticle_offline";
						endif;
				elseif ($catArt->isStartArticle() == true):
					$artClass = "startarticle";
				else:
					$artClass = "normarticle";
						if ($catArt->isOnline() == false):
							$artClass .= " normarticle_offline";
						endif;
				endif;
				
				//Aktivstatus prüfen
				if ($catArt->isStartArticle() != true && $catArt->isOnline() == true):
					$artStatus = "showArtOn";
				elseif ($catArt->isStartArticle() != true && $catArt->isOnline() == false):
					$artStatus = "showArtOff";
				else:
					$artStatus = "showArtStart";
				endif;
			
				//Linkname aufbereiten
				$linkname = a136_getName($catArt->getName(), $catArt->getId(), 1);
				
				$a136_rexTree .= "\t<li>";
				$a136_rexTree .= '<a href="index.php?page=content&amp;article_id='.$catArt->getId().'&amp;mode=edit&amp;clang='.$catArt->getClang().'&amp;category_id='.$ebene->getId().'" class="'.$artClass.'" rev="'.$catArt->getId().'|'.$ebene->getId().'|'.$REX['CUR_CLANG'].'" id="'.$artStatus.'" title="'.str_replace('"', "&quot;", $catArt->getName()).' (ID: '.$catArt->getId().')">'.$linkname.'</a>';
				$a136_rexTree .= "</li>\n";
			endforeach;                     			    
	endif;

	$a136_rexTree .= '</ul>';
}
function a136_getName($str, $id, $checkEmpty = 0)
{	global $REX, $I18N;
	global $rexTreeCfg;
	
	$str = trim($str);
	$name = $str;
		$name = (empty($name) && $checkEmpty == 1) ? '<span class="emptyname_art">'.$I18N->msg('a136_emptyname_art').'</span>' : $name;
		$name = (empty($name) && $checkEmpty == 2) ? '<span class="emptyname_cat">'.$I18N->msg('a136_emptyname_cat').'</span>' : $name;
		$name = ($rexTreeCfg[0]['chars'] == 1 && strlen($name) > $rexTreeCfg[0]['maxchars']) ? substr($name, 0,$rexTreeCfg[0]['maxchars'])."..." : $name;
		if ($rexTreeCfg[0]['showid'] == 1):
			$maxlen = intval($rexTreeCfg[0]['maxchars']) - 5;
			$name = ($rexTreeCfg[0]['chars'] == 1 && strlen($str) > $maxlen) ? substr($str, 0,$maxlen)."..." : $name;
			$name .= ' <span class="showid">['.intval($id).']</span>';
		endif;
	$str = $name;

	return $str;
}
?>