<?php
/*
	Redaxo-Addon RexTree
	Verwaltung: index
	v1.1
	by Falko Müller @ 2010-2013
	package: redaxo4
*/

//Variablen deklarieren
$mypage = "rextree";

$page = rex_request('page', 'string');
$subpage = rex_request('subpage', 'string');
$func = rex_request('func', 'string');

//Rexlayout :: Start
include $REX['INCLUDE_PATH'].'/layout/top.php';

//Untermenüs definieren

//Seitentitel ausgeben
rex_title($I18N->Msg('a136_title'), $subpages);

//globales Inline-CSS + Javascript
?>
<style type="text/css">
label { width: 180px !important; }							/* Rex-Label breiter machen */
input.rex-form-submit { margin-left: 190px !important; }	/* Rex-Button auf neue (Labelbreite +10) verschieben */
td.name { position: relative; padding-right: 20px; }
.nowidth { width: auto !important; }
.togglebox { display: none; margin-top: 8px; font-size: 90%; color: #666; line-height: 130%; }
.toggler { width: 15px; height: 12px; position: absolute; top: 10px; right: 3px; }
.toggler a { display: block; height: 11px; background-image: url(../files/addons/<?php echo $mypage; ?>/arrows.png); background-repeat: no-repeat; background-position: center -6px; cursor: pointer; }
.required { font-weight: bold; }
.inlinelabel { display: inline !important; width: auto !important; float: none !important; clear: none !important; padding: 0px  !important; margin: 0px !important; }
.form_auto { width: auto !important; }
.form_plz { width: 65px !important; margin-right: 6px; }
.form_ort { width: 380px !important; }
.form_half { width: 228px !important; }
.form_content { display: block; padding-top: 5px; }
.form_readonly { background-color: #EEE; color: #999; }
.form_isoffline { color: #A00; }
.addonfailed { color: #F00; font-weight: bold; margin-bottom: 15px; }
</style>
<?php

//Formular dieser Seite verarbeiten
if ($func == "save" && isset($_POST['submit'])):
	//Konfig speichern
	$db = rex_sql::factory();
	$db->setQuery("TRUNCATE TABLE ".$REX['TABLE_PREFIX']."136_rextree_config");

	$db = rex_sql::factory();
	$db->setTable($REX['TABLE_PREFIX']."136_rextree_config");

	$db->setValue("align", rex_request('rtree_align', 'int'));
	$db->setValue("context", rex_request('rtree_context', 'int'));
	$db->setValue("gui", rex_request('rtree_gui', 'int'));
	$db->setValue("chars", rex_request('rtree_chars', 'int'));
	$db->setValue("showid", rex_request('rtree_showid', 'int'));
	$db->setValue("allsites", rex_request('rtree_allsites', 'int'));
	
	if($db->insert()):
		echo rex_info($I18N->msg('a136_settings_saved'));
	else:
		echo rex_warning($I18N->msg('a136_error'));
	endif;
endif;

//Std.vorgaben der Felder auslesen
$db = rex_sql::factory();
$db->setQuery("SELECT * FROM ".$REX['TABLE_PREFIX']."136_rextree_config limit 0,1"); 
$rextreecfg = $db->getArray();	//mehrdimensionales Array kommt raus
	//Radio setzen
	if ($rextreecfg[0]['align'] == 1):
		$align1 = "";
		$align2 = 'checked="checked"';
	else:
		$align1 = 'checked="checked"';
		$align2 = "";
	endif;
?>

<div class="rex-addon-output">
    <div class="rex-form">
        <h2 class="rex-hl2"><?php echo $I18N->msg('a136_head'); ?></h2>
        
        <form action="index.php" method="post" id="rex-tree">
            <fieldset class="rex-form-col-1">
            
                <div class="rex-form-wrapper">
                    <input type="hidden" name="page" value="<?php echo $page; ?>" />
                    <input type="hidden" name="subpage" value="<?php echo $subpage; ?>" />
                    <input type="hidden" name="func" value="save" />
                    

                    <div class="rex-form-row">
                        <h5 class="rex-form-headline"><?php echo $I18N->msg('a136_subheader_cfg1'); ?></h5>
                    </div>
                    
                        <div class="rex-form-row">
                            <p class="rex-form-col-a rex-form-checkbox rex-form-label-left">
	                            <label><?php echo $I18N->msg('a136_cfg_status'); ?></label> 
                                <input class="rex-form-checkbox" name="rtree_allsites" type="checkbox" id="rtree_allsites" value="1" <?php echo ($rextreecfg[0]['allsites'] == 1) ? 'checked="checked"' : ''; ?> />
                                <label for="rtree_allsites" class="inlinelabel"><?php echo $I18N->msg('a136_cfg_yes'); ?> <?php echo $I18N->msg('a136_cfg_status_info'); ?></label>
                            </p>
                        </div>
                        
                        <div class="rex-form-row">
                            <p class="rex-form-col-a rex-form-checkbox rex-form-label-left">
	                            <label><?php echo $I18N->msg('a136_cfg_context'); ?></label> 
                                <input class="rex-form-checkbox" name="rtree_context" type="checkbox" id="rtree_context" value="1" <?php echo ($rextreecfg[0]['context'] == 1) ? 'checked="checked"' : ''; ?> />
                                <label for="rtree_context" class="inlinelabel"><?php echo $I18N->msg('a136_cfg_yes'); ?> <?php echo $I18N->msg('a136_cfg_context_info'); ?></label>
                            </p>
                        </div>
                        
                        <div class="rex-form-row">
                            <p class="rex-form-col-a rex-form-checkbox rex-form-label-left">
	                            <label><?php echo $I18N->msg('a136_cfg_chars'); ?></label> 
                                <input class="rex-form-checkbox" name="rtree_chars" type="checkbox" id="rtree_chars" value="1" <?php echo ($rextreecfg[0]['chars'] == 1) ? 'checked="checked"' : ''; ?> />
                                <label for="rtree_chars" class="inlinelabel"><?php echo $I18N->msg('a136_cfg_yes'); ?> <?php echo $I18N->msg('a136_cfg_chars_info'); ?></label>
                            </p>
                        </div>
                        
                        <div class="rex-form-row">
                            <p class="rex-form-col-a rex-form-checkbox rex-form-label-left">
	                            <label><?php echo $I18N->msg('a136_cfg_showid'); ?></label> 
                                <input class="rex-form-checkbox" name="rtree_showid" type="checkbox" id="rtree_showid" value="1" <?php echo ($rextreecfg[0]['showid'] == 1) ? 'checked="checked"' : ''; ?> />
                                <label for="rtree_showid" class="inlinelabel"><?php echo $I18N->msg('a136_cfg_yes'); ?> <?php echo $I18N->msg('a136_cfg_showid_info'); ?></label>
                            </p>
                        </div>
                        
                        <div class="rex-form-row">
                            <p class="rex-form-col-a rex-form-checkbox rex-form-label-left">
	                            <label><?php echo $I18N->msg('a136_cfg_gui'); ?></label> 
                                <input class="rex-form-checkbox" name="rtree_gui" type="checkbox" id="rtree_gui" value="1" <?php echo ($rextreecfg[0]['gui'] == 1) ? 'checked="checked"' : ''; ?> />
                                <label for="rtree_gui" class="inlinelabel"><?php echo $I18N->msg('a136_cfg_yes'); ?> <?php echo $I18N->msg('a136_cfg_gui_info'); ?></label>
                            </p>
                        </div>
                        
                        
                    <div class="rex-form-row">
                        <br />
						<h5 class="rex-form-headline"><?php echo $I18N->msg('a136_subheader_cfg2'); ?></h5>
                    </div>
                    
                        <div class="rex-form-row">
                            <p class="rex-form-col-a rex-form-checkbox rex-form-label-left">
                                <label class="rtalign">&nbsp;</label> 
                                <input class="rex-form-checkbox rtalign" name="rtree_align" type="radio" id="rtree_align_left" value="0" <?php echo $align1; ?> />
                                <label for="rtree_align_left" class="inlinelabel"><?php echo $I18N->msg('a136_cfg_left'); ?></label>
                            </p>
                  </div>
                        <div class="rex-form-row">
                            <p class="rex-form-col-a rex-form-checkbox rex-form-label-left">
                            	<label class="rtalign rtalign_right">&nbsp;</label> 
                                <input class="rex-form-checkbox rtalign" name="rtree_align" type="radio" id="rtree_align_right" value="1" <?php echo $align2; ?> />
                                <label for="rtree_align_right" class="inlinelabel"><?php echo $I18N->msg('a136_cfg_right'); ?></label>
                            </p>
                        </div>
                    
                        
                    
                    <div class="rex-form-row">
                        <p class="rex-form-submit">
                        	<br />
                            <input type="submit" class="rex-form-submit" name="submit" value="<?php echo $I18N->msg('a136_save'); ?>" />
                        </p>
                        <p>&nbsp;</p>
                    </div>
                </div>
                
            </fieldset>
        </form>
        
    </div>
</div>

<!-- PLEASE DO NOT REMOVE THIS COPYRIGHT -->
<p>&nbsp;</p>
<p><?php echo $REX['ADDON']['author'][$mypage]; ?></p>
<!-- THANK YOU! -->

<?php
//Rexlayout :: Ende
include $REX['INCLUDE_PATH'].'/layout/bottom.php';
?>
